#include "extern.h"
#include "aClient.h"
#include "player.h"
#include "flags.h"
#include "options.h"


void do_bank(char *u)
{
  char *cmd = strtok(NULL, " ");
  char *amount = strtok(NULL, " ");
  char *nick = strtok(NULL, " ");
  
  aClient *user;
  Player *p;
  
  if (!cmd || (!amount && stricmp(cmd, "BALANCE") != 0) || (stricmp(cmd, "TRANSFER") == 0 && !nick))
    {
	  notice(s_GameServ, u, "BANK {WITHDRAW | DEPOSIT} {ALL | AMOUNT}");
	  notice (s_GameServ, u, "BANK BALANCE");
	  return;
    }
  else if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Fatal Error. Couldn't find your aClient. Contact a(n) <S "\
			 " admin for help");
	  log("Fatal Error. Couldn't find %s while executing do_bank()", u);
	  return; 
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!is_playing(user))
    {
	  notice(s_GameServ, u, "You must be playing to use the bank!");
	  return;
    }
  else if (is_fighting(user))
    {
	  notice(s_GameServ, u, "You can't go to the bank during a fight!");
	  return;
    }
  updateTS(user->stats);
  if (stricmp(cmd, "BALANCE") == 0)
    {
	  showBankBalance(u);
	  return;
    }
  else if (!isAlive(user->stats))
    {
	  notice(s_GameServ, u, "You are dead. We don't accept gold from dead folk! Wait 'til tomorrow!");
	  return;
    }
  else if (!isstringnum(amount) && stricmp(amount, "ALL") != 0)
    {
	  notice(s_GameServ, u, "I don't know how to convert alphabet letters into currency, sire!");
	  return;
    }
  if (stringtoint(amount) < 0)
    {
	  notice(s_GameServ, u, "Sorry. This bank is not licensed "\
			 "to handle such sums of cash, noble Lord.");
	  return;
    }
  p = user->stats;
  
  if (stricmp(cmd, "DEPOSIT") == 0)
    {
	  if (p->getBank() == 2000000000)
        {
		  notice(s_GameServ, u, "Your bank account is full, sire!");
		  return;
        }
	  else if (stricmp(amount, "ALL") == 0)
        {
		  if (2000000000 - p->getBank() < p->getGold())
            {
			  notice(s_GameServ, u, "You don't have enough room for all of your gold.");
			  notice(s_GameServ, u, "Depositing %ld gold into your account", (2000000000 - p->getBank()));
			  p->subtractGold((2000000000 - p->getBank()));
			  p->setBank(2000000000);
			  showBankBalance(u);
            }
		  else
            {
			  notice(s_GameServ, u, "Depositing %ld gold into your account!", p->getGold());
			  p->addBank(p->getGold());
			  p->setGold(0);
			  showBankBalance(u);
            }
        }
	  else if (stringtoint(amount) > p->getGold())
        {
		  notice(s_GameServ, u, "Sire, you only have %ld gold!", p->getGold());
		  showBankBalance(u);
		  return;
        }
	  else
        {
		  if (2000000000 - p->getBank() < stringtoint(amount))
            {
			  notice(s_GameServ, u, "You don't have room in your account for that much.");
			  notice(s_GameServ, u, "Capping off your account with %ld gold!", (2000000000 - p->getBank()));
			  p->subtractGold((2000000000 - p->getBank()));
			  p->setBank(2000000000);
			  showBankBalance(u);
            }
		  else
            {
			  notice(s_GameServ, u, "Depositing %d gold into your account!", stringtoint(amount));
			  p->addBank(stringtoint(amount));
			  p->subtractGold(stringtoint(amount));
			  showBankBalance(u);
            }
        }
    }
  else if (stricmp(cmd, "WITHDRAW") == 0)
    {
	  if (p->getGold() == 2000000000)
        {
		  notice(s_GameServ, u, "You cannot carry any more gold, sire!");
		  showBankBalance(u);
		  return;
        }
	  else if (stricmp(amount, "ALL") == 0)
        {
		  if (2000000000 - p->getGold() < p->getBank())
            {
			  notice(s_GameServ, u, "You don't have enough room to carry all that gold.");
			  notice(s_GameServ, u, "Withdrawing %ld gold from your account", (2000000000 - p->getGold()));
			  p->subtractBank((2000000000 - p->getGold()));
			  p->setGold(2000000000);
			  showBankBalance(u);
            }
		  else
            {
			  notice(s_GameServ, u, "Withdrawing %ld gold from your account!", p->getBank());
			  p->addGold(p->getBank());
			  p->setBank(0);
			  showBankBalance(u);
            }
        }
	  else if (stringtoint(amount) > p->getBank())
        {
		  notice(s_GameServ, u, "Sire, you only have %ld gold in the bank!", p->getBank());
		  showBankBalance(u);
		  return;
        }
	  else
        {
		  if (2000000000 - p->getGold() < stringtoint(amount))
            {
			  notice(s_GameServ, u, "You don't enough have room to carry that much gold!");
			  notice(s_GameServ, u, "You fill your pockets with %ld gold!",
					 (2000000000 - p->getGold()));
			  p->subtractBank((2000000000 - p->getGold()));
			  p->setGold(2000000000);
			  showBankBalance(u);
            }
		  else
            {
			  notice(s_GameServ, u, "Withdrawing %d gold from your account!", stringtoint(amount));
			  p->addGold(stringtoint(amount));
			  p->subtractBank(stringtoint(amount));
			  showBankBalance(u);
            }
        }
    } 
}
