#include "extern.h"
#include "options.h"
#include "player.h"
#include "aClient.h"
#include "flags.h"
#include "toplist.h"

void do_list(char *u)
{
  aClient *user;
  Player *p;
  char *cmd = strtok(NULL, " ");
  
  if (!(user = find(u)))
    {
	  log("Fatal Error: Couldn't find %s in the client list", u);
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s. Command LIST", user->getNick());
#endif
	  return;
    }
  
  if (cmd == NULL || stricmp(cmd, "TOP") == 0)
  {
    list<PlayerWrapper>::iterator iter;
    bool header = false;

    if (myToplist.empty())
      {
         notice(s_GameServ, u, "There are no players");
         return;
      }
    myToplist.sort();
    myToplist.reverse();
     
    iter = myToplist.begin();
     
    while (iter != myToplist.end())
    {
        if (!header)
        {
           notice(s_GameServ, u, "Top Players");
           header = true;

        }
        notice(s_GameServ, u, "Level: %2d Exp: %-10d Name: %s", 
        (*iter).getLevel(), (*iter).getExp(), (*iter).getName().c_str());
        iter++;
     }
  }
  else
  {
        
     list<Player*>::iterator iter;
     bool header = false;
   
     for (unsigned long x = 0; x < U_TABLE_SIZE; x++)
      {
        iter = players[x].begin();
        if (!players[x].empty())
         {
           while(iter != players[x].end())
            {
              p = (*iter);
              if (cmd || is_playing(p->getClient()))
               {
                 if (!header)
                  {
                    notice(s_GameServ, u, "Players:");
                    header = true;
                  }
      #ifdef P10
                 notice(s_GameServ, u, "IRC: %s     Game: %s", (p->getClient() ? p->getClient()->getRealNick() : "Not Playing"), 
                      p->getName().c_str());
      #else
                 notice(s_GameServ, u, "IRC: %s     Game: %s", (p->getClient() ? p->getClient()->getNick() : "Not Playing"), 
                      p->getName().c_str());
      #endif
               }
              iter++;
            }
         }
      }
     if (!header)
      notice(s_GameServ, u, "No one is playing");
     else
      notice(s_GameServ, u, "End of List"); 
   }
}
