#include "extern.h"
#include "config.h"
#include "aClient.h"
#include "flags.h"
#include "player.h"
#include "options.h"


void do_logout(char *u)
{
  aClient *user;
  Player *p;
  char *name = strtok(NULL, " ");
  
  if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Fatal error. Cannot find aClient. "\
			 "Buf: %s LOGOUT", u);
	  log("Could not find aClient Buf: %s LOGOUT", 
		  u);
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  
  if (name)
    {
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "You must be a <S admin to use this command!");
		}
	  else if (!(p = findplayer(name)))
		{
		  notice(s_GameServ, u, "Couldn't find a player named %s", name);
		}
	  else
		{
		  notice(s_GameServ, u, "Logging out %s", p->getName().c_str());
		  logout(p->getClient());
		}
    }
  else if (!name)
    {
	  if (!is_playing(user))
		{
		  notice(s_GameServ, u, "You're not logged in!");
		}
	  else if (is_fighting(user))
		{
		  notice(s_GameServ, u, "You can't logout while fighting!");
		}
	  else
		{
		  notice(s_GameServ, u, "You have left the fields. You have lived to kill another day!");
		  logout(user);
		}
    }
}
