#include "extern.h"
#include "options.h"
#include "aClient.h"
#include "player.h"
#include "flags.h"

void do_refresh(char *u)
{
  char *name = strtok(NULL, " ");
  aClient *user;
  Player *p;
  
  if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Error: aClient not found. Contact a <S admin");
	  log("Error: aClient not found: %s", u);
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!isAdmin(user))
    {
	  notice(s_GameServ, u, "You must be a <S admin to use this command!");
	  return;
    }
  if (!name)
    {
	  notice(s_GameServ, u, "SYNTAX: REFRESH {ALL | NICK}");
	  return;
    }
  else if (stricmp(name, "ALL") == 0)
    {
	  notice(s_GameServ, u, "Refreshing everyone's stats!");
	  refreshall();
    }
  else if ((p = findplayer(name)))
    {
	  notice(s_GameServ, u, "Refreshing %s.", p->getName().c_str());
	  refresh(p);
	}
  else
    {
	  notice(s_GameServ, u, "Player %s not found.", name);
	  return;
    }
}
