#include "extern.h"
#include "options.h"
#include "aClient.h"
#include "player.h"
#include "flags.h"
#include "pouch.h"
#include "item.h"
#include "toplist.h"

void do_register(char *u)
{
  char *password, *name;
  aClient *user;
  Player *p;
  name = strtok(NULL, " ");
  password = strtok(NULL, " ");
  
  if (!name)
    {
	  notice(s_GameServ, u, "SYNTAX: /msg <S REGISTER NAME PASSWORD");
    }
  else if (stricmp(name, s_GameServ) == 0)
    {
	  notice(s_GameServ, u, "You can't use <S as a name!");
    }
  else if (!password)
    {
	  notice(s_GameServ, u, "SYNTAX: /msg <S REGISTER NAME PASSWORD");
    }
  else if (strlen(name) > maxnicklen)
	{
	  notice(s_GameServ, u, "Name too long. Maximum length: %d", maxnicklen);
	}
  else if (!alphaNumeric(name))
	{
	  notice(s_GameServ, u, "That is not a valid name. Please use only AlphaNumeric (A-Z, 0-9) characters!");
	}
  else if ((p = findplayer(name)))
    {
	  notice(s_GameServ, u, "%s is already registered!", name);
	  notice(s_GameServ, u, "Choose another name!");
    }
  else if (!(user = find(u)))
    {
	  log("Fatal Error: Couldn't find %s in the clients list", u);
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
    }
  else
    {
	  if (!is_playing(user))
        {
		  item *tempItem;
		  unsigned long hv = iHASH((unsigned char *) name);

		  // First create the Player
		  user->stats = new Player();

		  // Set the backwards pointer
		  user->stats->setClient(user);

		  // Set the player's password
		  user->stats->setPassword(password);

		  // Set the player's name
		  user->stats->setName(name);

		  // Make sure they have a proper time stamp
		  updateTS(user->stats);

		  // Update the last login time
		  user->stats->lastlogin = time(NULL);
		  
		  // Send notification of success
		  notice(s_GameServ, u, "Player %s registered with password %s.", user->stats->getName().c_str(), password);
		  notice(s_GameServ, u, "Write this password down. If you lose it, there is no way to retrieve it!");

		  // Log the new player
		  log("Nickname %s registered player %s.", u, user->stats->getName().c_str());

		  // Log the player in
		  setPlaying(user);

		  // Start the player at the beginning
		  reset(user->stats);
		  
		  // Add the stick and clothes
		  tempItem = findItemByID(3001);
		  user->stats->inventory->addItem((*Items.begin()))->use(user->stats); // Add the stick
		  user->stats->inventory->addItem(tempItem)->use(user->stats); // Add Clothes

		  // Add the player to the list
		  players[hv].push_back(user->stats);

		  // Attempt to add the player to the top list
		  // The class takes care of pruning the user out if they don't deserve to be in the list
		  myToplist.insertPlayer(user->stats);
		}
	  else
		{
		  notice(s_GameServ, u, "Already registered. Contact a <S admin for help.");
		}
    }
}
