#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"
#include "player.h"

void do_set(char *u)
{
  aClient *user;
  Player *p;
  char *name = strtok(NULL, " ");
  char *cmd = strtok(NULL, " ");
  char *cmd2;
  
  if (!(user = find(u)))
    {
      notice(s_GameServ, u, "Fatal error. Cannot find aClient. "\
			 "Buf: %s LOGOUT", u);
      return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
      log("Ignoring %s.", user->getNick());
#endif
      return;
    }
  else if (!name || !cmd)
    {
      notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] {PASSWORD|BANK BALANCE|PLAYER FIGHTS|FOREST FIGHTS|GOLD|STRENGTH|DEFENSE|HP|MAXHP|EXP|LEVEL|ALIVE|SEEN MASTER} {STRING|NUMBER|TRUE|FALSE}");
      return;
    }
  else if (!(p = findplayer(name)))
    {
      // Back the pointers up... they didn't send a name probably
      cmd2 = cmd;
      cmd = name;
      p = user->stats;
	  
      if (!is_playing(user))
		{
		  notice(s_GameServ, u, "You must be playing to set things for yourself!");
		  return;
		}
    }
  else
    {
      cmd2 = strtok(NULL, " ");
    }
  if (!cmd2)
	{
	  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] {PASSWORD|BANK BALANCE|PLAYER FIGHTS|FOREST FIGHTS|GOLD|STRENGTH|DEFENSE|HP|MAXHP|EXP|LEVEL|ALIVE|SEEN MASTER} {STRING|NUMBER|TRUE|FALSE}");
	  return;
	}
  
  // Regardless of the previous if/else, if it got here, we know we have the cmd pointer at the right spot.
  if (stricmp(cmd, "PASSWORD") == 0)
    {
      // Person is looking to change their password
      // If they're an admin, or it's theirself, allow it
      // cmd2 is pointing to the password now
      if (isAdmin(user) || user == p->getClient())
		{
		  p->setPassword(cmd2);
		  notice(s_GameServ, u, "Password successfully changed");
		}
      else if (user != p->getClient() && !isAdmin(user))
		{
		  notice(s_GameServ, u, "You must be a <S admin to set other peoples' passwords.");
		  return;
		}
    }
  else if (stricmp(cmd, "BANK") == 0 || stricmp(cmd, "BALANCE") == 0)
    {
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
	  else if (stricmp(cmd, "BANK") == 0)
		{
		  cmd2 = strtok(NULL, " "); // Need an extra parameter for set bank balance
		}
	  if (!cmd2)
		{
		  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] [BANK] BALANCE <NUMBER>");
		  return;
		}
	  
	  p->setBank(stringtoint(cmd2));
	  
	  notice(s_GameServ, u, "Bank balance changed to %ld!", p->getBank());
    }
  else if (stricmp(cmd, "PLAYER") == 0)
    {
      if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
      else if (stricmp(cmd2, "FIGHTS") != 0)
		{
		  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] PLAYER FIGHTS <NUMBER>");
		  return;
		}
      else
		{
		  cmd2 = strtok(NULL, " ");
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] PLAYER FIGHTS <NUMBER>");
			  return;
			}
		  p->setPlayerFights(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Player fights changed to %d!", p->getPlayerFights());
		}	  
    }
  else if (stricmp(cmd, "FOREST") == 0)
    {
      if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
      else if (stricmp(cmd2, "FIGHTS") != 0)
		{
		  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] FOREST FIGHTS <number>");
		  return;
		}
      else
		{
		  cmd2 = strtok(NULL, " ");
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] FOREST FIGHTS <NUMBER>");
			  return;
			}
		  
		  p->setForestFights(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Forest fights changed to %d!", p->getForestFights());
		}	  
    }
  else if (stricmp(cmd, "GOLD") == 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] GOLD <NUMBER>");
			  return;
			}
		  p->setGold(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Gold set to %ld", p->getGold());
		  return;
		}
	}
  else if (stricmp(cmd, "STRENGTH") == 0 && stricmp(cmd2, "POTIONS") != 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] STRENGTH <NUMBER>");
			  return;
			}
		  
		  p->setStrength(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Strength set to %d", p->getStrength());
		  return;
		}
	}
  else if (stricmp(cmd, "DEFENSE") == 0 && stricmp(cmd2, "POTIONS") != 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] DEFENSE <NUMBER>");
			  return;
			}
		  
		  p->setDefense(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Defense set to %d", p->getDefense());
		  return;
		}
	}
  else if (stricmp(cmd, "HP") == 0 && stricmp(cmd2, "POTIONS") != 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] HP <NUMBER>");
			  return;
			}

		  // Make sure it's easy for an admin to set the hp
		  if (p->getMaxHP() < stringtoint(cmd2))
			p->setMaxHP(stringtoint(cmd2));
		  
		  p->setHP(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "HP set to %d", p->getHP());
		  return;
		}
	}
  else if (stricmp(cmd, "MAXHP") == 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] MAXHP <NUMBER>");
			  return;
			}
		  p->setMaxHP(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "MaxHP set to %d", p->getMaxHP());
		  return;
		}
	}
  else if (stricmp(cmd, "EXPERIENCE") == 0 || stricmp(cmd, "EXP") == 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] {EXPERIENCE|EXP} <NUMBER>");
			  return;
			}
		  
		  p->setExp(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Exp set to %ld", p->getExp());
		  return;
		}
	}
  else if (stricmp(cmd, "LEVEL") == 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;	  
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] LEVEL <NUMBER>");
			  return;
			}
		  p->setLevel(stringtoint(cmd2));
		  
		  notice(s_GameServ, u, "Level set to %d", p->getLevel());
		  return;
		}
	}
  else if (stricmp(cmd, "ALIVE") == 0)
	{
	  if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
	  else
		{
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] ALIVE TRUE|FALSE");
			  return;
			}
		  else if (stricmp(cmd2, "TRUE") == 0)
			{
			  notice(s_GameServ, u, "%s has been Resurrected!", p->getName().c_str());
			  setAlive(p);
			}
		  else
			{
			  notice(s_GameServ, u, "%s is now dead!", p->getName().c_str());
			  clearAlive(p);
			}
		}
	}
  else if (stricmp(cmd, "SEEN") == 0)
    {
      if (!isAdmin(user))
		{
		  notice(s_GameServ, u, "Admins Only!");
		  return;
		}
      else if (stricmp(cmd2, "MASTER") != 0)
		{
		  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] SEEN MASTER {TRUE|FALSE}");
		  return;
		}
      else
		{
		  cmd2 = strtok(NULL, " ");
		  if (!cmd2)
			{
			  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NICK] SEEN MASTER {TRUE|FALSE}");
			  return;
			}
		  else if (stricmp(cmd2, "TRUE") == 0)
			{
			  notice(s_GameServ, u, "%s has seen their master now.", p->getName().c_str());
			  p->addFlag(FLAG_MASTER);
			}
		  else
			{
			  notice(s_GameServ, u, "%s has not seen their master now.", p->getName().c_str());
			  p->remFlag(FLAG_MASTER);
			}
		}	  
    }
  else
	{
	  notice(s_GameServ, u, "Unknown command: SET %s", cmd);
	  notice(s_GameServ, u, "SYNTAX: /msg <S SET [NAME] {PASSWORD|BANK BALANCE|PLAYER FIGHTS|FOREST FIGHTS|GOLD|STRENGTH|DEFENSE|HP|MAXHP|EXP|LEVEL|ALIVE|SEEN MASTER} {STRING|NUMBER|TRUE|FALSE}");
	  return;
	}
}
