#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"
#include "player.h"
#include "item.h"
#include "pouch.h"

void do_tavern(char *u)
{
  char *cmd = strtok(NULL, " ");

  aClient *user;
  Player *p;
  
  if (!(user = find(u)))
    {
      notice(s_GameServ, u, "Fatal Error. See a <S admin for help");
      return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
      log("Ignoring %s.", user->getNick());
#endif
      return;
    }
  else if (!is_playing(user))
    {
      notice(s_GameServ, u, "You must be playing to go to the Tavern");
      return;
    }
  else if (is_fighting(user))
    {
      notice(s_GameServ, u, "You cannot go to the Tavern during a fight!");
      return;
    }
  
  updateTS(user->stats);
  p = user->stats;
  
  if (!cmd)
    {
      notice(s_GameServ, u, "Welcome to Boot Liquors Mystic Apothecary and General Store");
      notice(s_GameServ, u, "Your commands:");
      notice(s_GameServ, u, "/msg <S TAVERN {LIST | BUY} [NUMBER]");
      notice(s_GameServ, u, "What'll it be?");
    }
  else if (stricmp(cmd, "LIST") == 0)
    {
      notice(s_GameServ, u, "Here is a list of what we have to offer:");
      showTavern(user);
      notice(s_GameServ, u, "To buy an item, type /msg <S TAVERN BUY #");
    }
  else if (stricmp(cmd, "BUY") == 0)
    {
	  int amt = 1;
      char *chid = strtok(NULL, " ");
	  char *amount = strtok(NULL, " ");

	  if (amount)
		amt = stringtoint(amount);
      
      if (!chid)
		{
		  notice(s_GameServ, u, "SYNTAX: TAVERN BUY # [#]");
		  notice(s_GameServ, u, "Example: /msg <S TAVERN BUY 6001");
		  notice(s_GameServ, u, "Example: /msg <S TAVERN BUY 6001 10");
		  return;
		}
      long id = stringtoint(chid);
      tavernItem *tempItem;
      
      if (!(tempItem = findTavernItemByID(id)) || user->stats->getLevel() < tempItem->getLevel())
		{
		  notice(s_GameServ, u, "Invalid Choice!");
		  notice(s_GameServ, u, "Here is a list of what we have to offer:");
		  showTavern(user);
		  notice(s_GameServ, u, "To buy an item, type /msg <S TAVERN BUY #");
		  return;
		}
      else if (!amount && user->stats->getGold() < tempItem->getItem()->price())
		{
		  notice(s_GameServ, u, "You don't have enough gold!");
		  notice(s_GameServ, u, "Here is a list of what we have to offer:");
		  showTavern(user);
		  notice(s_GameServ, u, "To buy an item, type /msg <S TAVERN BUY #");
		}
	  else if (user->stats->getGold() < amt * tempItem->getItem()->price())
		{
		  notice(s_GameServ, u, "You don't have enough gold!");
		  notice(s_GameServ, u, "Here is a list of what we have to offer:");
		  showTavern(user);
		  notice(s_GameServ, u, "To buy an item, type /msg <S TAVERN BUY # [#]");
		}
	  else
		{
		  if (amount)
			{
			  int amt = stringtoint(amount);
			  if (amt < 0 || amount[0] == '-')
				{
				  notice(s_GameServ, u, "You trying to steal from me?");
				}
			  else if (user->stats->inventory->addItem(tempItem->getItem(), amt) == NULL)
				{
				  notice(s_GameServ, u, "You can't carry that many!");
				}
			  else
				{
				  notice(s_GameServ, u, "%d %s's coming right up!", amt, tempItem->getItem()->getName().c_str());
				  user->stats->subtractGold(tempItem->getItem()->price() * amt);
				}
			}
		  else
			{
			  if (user->stats->inventory->addItem(tempItem->getItem()) == NULL)
				{
				  notice(s_GameServ, u, "You can't carry any more!");
				}
			  else
				{
				  notice(s_GameServ, u, "One %s coming right up!", tempItem->getItem()->getName().c_str());
				  user->stats->subtractGold(tempItem->getItem()->price());
				}
			}
		}
    }
  else
    {
      notice(s_GameServ, u, "Improper Syntax.");
      notice(s_GameServ, u, "Type /msg <S HELP TAVERN for help");
    }
  return;
}

