#include "aClient.h"
#include "config.h"
#include "extern.h"
#include "player.h"
#include "pouch.h"
#include "flags.h"
#include "level.h"
#include "sockhelp.h"
#include "item.h"
#include "script.h"
#include "toplist.h"

#include <algorithm>
#include <cctype>
#include <fstream>
#include <stdlib.h>
#include <list>
#include <iterator>

using namespace std;

#if defined(HAVE_CRYPT_H)

#include <crypt.h>

#elif defined(HAVE_UNISTD_H)

#include <unistd.h> 

#endif


Level levels[LEVELS];			// The newest way to store monsters
list<item*> Items;                      // The master list of items
list<tavernItem> tavern;                // The list of items available at the tavern
list<item*> store;                      // List of items available at the store

toplist myToplist;          // List of the top 10 players



bool shuttingdown;

#define WNA 16

int hpbonus[11] = {10, 15, 20, 30, 50, 75, 125, 185, 250, 350, 550};
int strbonus[11] = {5, 7, 10, 12, 20, 35, 50, 75, 110, 150, 200};
int defbonus[11] = {2, 3, 5, 10, 15, 22, 35, 60, 80, 120, 150};

void gameserv(char *source, char *buf)
{
  char *cmd, z;
  cmd = strtok(buf, " ");
  
#ifndef P10
  source++; // Get rid of that : at the beginning of a :Nick privmsg Gameserv :text
#endif
  
  z = cmd[0];
  if (z == ':')
	cmd++;    // Get rid of that : at the beginning of the :text  (command)
  
#ifdef DEBUGMODE
  log("Source: %s  Command: %s", source, cmd);
#endif
  
  if (strnicmp(cmd, "\1PING", 6) == 0)
    {
	  char *ts;
	  ts = strtok(NULL, "\1");
	  notice(s_GameServ, source, "\1PING %s\1", ts);
    }
  else if (stricmp(cmd, "\1VERSION\1") == 0)
	{
	  notice(s_GameServ, source, "\1VERSION %s %s\1", PACKAGE.c_str(), VERSION.c_str());
    }
  else if (stricmp(cmd, "SEARCH") == 0)
	{
	  cmd = strtok(NULL, " ");
	  
	  if (!cmd)
	    notice(s_GameServ, source, "SYNTAX: /msg <S SEARCH FOREST");
	  else
	    do_forest(source);
	  
    }
  else if (stricmp(cmd, "ADMIN") == 0)
	{
	  do_admin(source);
    }
  else if (stricmp(cmd, "ATTACK") == 0)
	{
	  do_attack(source);
    }
  else if (stricmp(cmd, "BANK") == 0)
	{
	  do_bank(source);
    }
  else if (stricmp(cmd, "CHECK") == 0)
	{
	  do_check(source);
    }
  else if (stricmp(cmd, "DRAGON") == 0)
	{
	  do_dragon(source);
    }
  else if (stricmp(cmd, "EQUIP") == 0)
	{
      do_equip(source);
    }
  else if (stricmp(cmd, "FIGHT") == 0)
	{
	  do_fight(source);
    }
  else if (stricmp(cmd, "HEAL") == 0)
	{
	  do_heal(source);
    }
  else if (stricmp(cmd, "HELP") == 0)
	{
	  do_help(source);
    }
  else if (stricmp(cmd, "IDENTIFY") == 0)
	{
	  do_identify(source);
    }
  else if (stricmp(cmd, "INVENTORY") == 0)
	{
	  do_inventory(source);
    }
  else if (stricmp(cmd, "LIST") == 0)
	{
	  do_list(source);
    }
  else if (stricmp(cmd, "LOGOUT") == 0)
	{
	  do_logout(source);
    }
  else if (stricmp(cmd, "MASTER") == 0)
	{
	  do_master(source);
    }
  else if (stricmp(cmd, "NEWS") == 0)
	{
	  do_news(source);
    }
  else if (stricmp(cmd, "REGISTER") == 0)
	{
	  do_register(source);
    }
  else if (stricmp(cmd, "REFRESH") == 0)
	{
	  do_refresh(source);
    }
  else if (stricmp(cmd, "RESET") == 0)
	{
	  do_reset(source);
    }
  else if (stricmp(cmd, "RUN") == 0)
	{
	  do_run(source);
    }
  else if (stricmp(cmd, "SET") == 0)
	{
	  do_set(source);
    }
  else if (stricmp(cmd, "STATS") == 0)
	{
	  do_stats(source);
    }
  else if (stricmp(cmd, "STORE") == 0)
	{
	  do_store(source);
    }
  else if (stricmp(cmd, "TAVERN") == 0)
	{
	  do_tavern(source);
    }
  else if (stricmp(cmd, "USE") == 0)
	{
	  do_use(source);
    }
  else if (stricmp(cmd, "SHUTDOWN") == 0)
	{
          do_shutdown(source);
    }
  else if (stricmp(cmd, "SAVE") == 0)
	{
          do_save(source);
    }
  else if (stricmp(cmd, "LOAD") == 0)
	{
          do_load(source);
	}
#ifdef DEBUGMODE
  else if (stricmp(cmd, "RAW") == 0)
	{
          do_raw(source);
    }
#endif
  else
	{
	  aClient *user;
	  if ((user = find(source)))
		{
		  if (isIgnore(user))
			{
#ifdef DEBUGMODE
			  log("Ignoring %s.", user->getNick());
#endif
			}
		  else
			{
			  notice(s_GameServ, source, "Unknown command \002%s\002. Type /msg <S \002HELP\002 to get a list of commands.", cmd);
			}
		}
    }

#ifndef P10
  source--;  // Bring the ':' back 
#endif
  if (z == ':')
	cmd--;     // Same thing :)
}

