#ifndef TOPLIST_H
#define TOPLIST_H

#include <list>
#include <string>
#include "player.h"

using namespace std;

// Forward declaration
class Player;
class aClient;
class Monster;
class item;

class PlayerWrapper
{
   public:
   PlayerWrapper();
   PlayerWrapper(Player *pl);
   ~PlayerWrapper();
   
   void setPlayer(Player *pl);
   
   string getName() { return p->getName(); };
   int getLevel() { return p->getLevel(); };
   long int getExp() { return p->getExp(); };
   long int getGold() { return p->getGold(); };
   long int getBank() { return p->getBank(); };
   int getHP() { return p->getHP(); };
   int getMaxHP() { return p->getMaxHP(); };
   int getStrength() { return p->getStrength(); };
   int getDefense() { return p->getDefense(); };
   int getForestFights() { return p->getForestFights(); };
   int getPlayerFights() { return p->getPlayerFights(); };
   string getPassword() { return p->getPassword(); };

   aClient *getClient() { return p->getClient(); };
   Monster *getMonster() { return p->getMonster(); };
   Monster *getMaster() { return p->getMaster(); };
   aClient *getBattle() { return p->getBattle(); };

   bool operator < (PlayerWrapper &right);
   
   private:
   Player *p;
};

class toplist 
{
public:
  // Default Constructor
  toplist();

  // Constructor with a parameter for the count
  toplist(int);

  // Destructor
  ~toplist();

  // Insert the player into the top list if they make it
  void insertPlayer(Player *);

  // Set how many players should be in the toplist
  void setCount(int);
  int getCount() { return count; };

  // Sort the list
  void sort();

  // Prune the list so it's not larger than the count
  void prune();
  
  void reverse();

  list<PlayerWrapper>::iterator begin();
  list<PlayerWrapper>::iterator end();
  bool empty();

private:

  // The actual list of players
  list<PlayerWrapper> myList;

  // The number of players to keep in the list
  int count;
};



#endif
